function [] = addTextToFigure(figNum,relXpos,relYpos,textInput,varargin)
% This function adds text to the figure 'figNum' at bottom left position
% [relXpos,relYpos]. Text added is 'textInput'. varargin gives any text
% modifiers allowed by the function text(). This includes font, fontsize,
% color, etc.

figure(figNum)
ax = axis();
if strcmp(get(gca,'xscale'),'log')
    xshift = exp(log(ax(1)) + relXpos*(log(ax(2))-log(ax(1))));
else
    xshift = ax(1) + relXpos*(ax(2)-ax(1));
end

if strcmp(get(gca,'yscale'),'log')
    yshift = exp(log(ax(3)) + relYpos*(log(ax(4))-log(ax(3))));
else
    yshift = ax(3) + relYpos*(ax(4)-ax(3));
end

text(xshift,yshift,textInput,varargin{:});

end