function [] = ZvsDBoundaryConditions()
% This function plots Fig. 1, which uses a triangular lattice in 2d

pos = []; 
rad = ones(61,1) * 0.6;

for i = -5:5
    for j = -5:5 
        if mod(i+j,2)==0 
            pos = [pos; i j]; 
        end
    end
end

lwc = 3;
lw = 3;
zc = 'r';
dc = 'b';

figure(111)
clf; hold all
h = viscircles(pos,rad,'color','k','linewidth',lwc);
axis([-3 3 -3 3])

for i = 1:3
    plot([-i -i],[-i i],'-','Linewidth',lw,'color',zc)
    plot([i i],[-i i],'-','Linewidth',lw,'color',zc)
    plot([-i i],[-i -i],'-','Linewidth',lw,'color',zc)
    plot([-i i],[i i],'-','Linewidth',lw,'color',zc)
end

for i = 1:5
    plot([-i 0],[0 i],'-','Linewidth',lw,'color',dc)
    plot([-i 0],[0 -i],'-','Linewidth',lw,'color',dc)
    plot([0 i],[i 0],'-','Linewidth',lw,'color',dc)
    plot([0 i],[-i 0],'-','Linewidth',lw,'color',dc)
end
box off
xticks([])
yticks([])
axis square

end