function [] = phiCoexPhiD()
% This function plots the main portion of Fig. 6, where each phi is taken
% from other functions or papers.

d = (1:60)';

phic = [NaN, 2*sqrt(3)/3, 2^(3/2-1),2^(4/2-1),2^(5/2-1),pi^3/(48 * sqrt(3)) / hyperBallVolume(6) * 2^6,2^7/16,pi^4/(2^4 * 4*3*2) / hyperBallVolume(8) * 2^8, 2^(9/2), 40].*hyperBallVolume(1:10)./(2.^(1:10));
            
phion = [NaN
    NaN
    0.46
    0.293
    0.19
    0.11
    0.065
    0.04];

phionerr = [NaN
    NaN
    0.02
    0.006
    0.02
    0.01
    0.005
    0.002];

phid = [NaN
    NaN
    0.57700000000000
    0.403600000000000
    0.2683
    0.172300000000000
    0.107600000000000
    0.065850000000000
    0.0391
    0.0226];

phiderr = [NaN
    NaN
    0.0005
    0.0002
    0.0001
    0.0001
    0.0001
    0.0005
    0.0006
    0.0001];

figure(137)
clf; hold all
plot(1./(1:10)',2.^(1:10).*phic./(1:10),'p-','MarkerSize',10,'Color',[0.5 0.5 0.5],'MarkerFaceColor',[0.5 0.5 0.5],'Linewidth',2)
errorbar(1./d(~isnan(phid)),2.^d(~isnan(phid)).*phid(~isnan(phid))./d(~isnan(phid)),2.^d(~isnan(phid)).*phiderr(~isnan(phid))./d(~isnan(phid)),'d-','MarkerSize',10,'Color','m','MarkerFaceColor','m','Linewidth',2)

xlabel('$1/d$','interpreter','latex')
ylabel('$\widehat{\varphi}$','interpreter','latex')
axis([0.1 0.35 0.9 3])
plotSpecs()
set(gca,'Linewidth',2)
set(gca,'FontSize',20)

phif = [NaN 0.7 0.4919 0.3031 0.1942 0.1129 0.0647995 0.035 0.0204056 0.012559167472574];
phim = [NaN 0.716 0.5434 0.3653 0.2484 0.1567 0.09636 0.0558 0.03248 0.021602962560232];

figure(137)
errorbar(1./(1:10),(phim.*2.^(1:10))./(1:10),[NaN 0.0004 0.0003 0.0003 0.0002 0.0002 0.0002 0.0002 0.0006 0.0003].*2.^(1:10)./(1:10),'s-b','MarkerSize',10,'linewidth',2,'markerfacecolor','b')
errorbar(1./d(~isnan(phion)),2.^d(~isnan(phion)).*phion(~isnan(phion))./d(~isnan(phion)),2.^d(~isnan(phion)).*phionerr(~isnan(phion))./d(~isnan(phion)),'o-k','MarkerSize',10,'MarkerFaceColor','k','LineWidth',2)
errorbar(1./(1:10),(phif.*2.^(1:10))./(1:10),[NaN 0.0003 0.0003 0.0001 0.0001 0.0001 0.0001 0.0005 0.0008 0.0003].*2.^(1:10)./(1:10),'v-','Color','r','MarkerSize',10,'linewidth',2,'markerfacecolor','r')
legend('$\widehat{\varphi}_c$','$\widehat{\varphi}_d$','$\widehat{\varphi}_{m}$','$\widehat{\varphi}_{nf}$','$\widehat{\varphi}_{f}$','NumColumns',1,'location','northwest','interpreter','latex','fontsize',15)
axis([0 0.55 0 11])
set(gcf,'units','points','position',[10,10,550,5*400])
pbaspect([3*2.000000000000000   5*1.236000000000000   1.000000000000000])

end