import monteCarloPCP as mc
import numpy as np
from scipy.special import gamma
import liquidCrystalCoexistence.e6Crystal as e6
import liquidCrystalCoexistence.dDCrystal as dD
import sys
import os
import glob


# def gofr(pos,rad,numSteps,maxRad = None,minRad = None,neighbors = None, numVolumePoints = 1000000):
# 	nParticles = pos.shape[0]
# 	dim = pos.shape[1]
# 	if (maxRad is None or maxRad > np.sqrt(dim)/2):
# 		maxRad = np.sqrt(dim)/2
# 	if (minRad is None or minRad < 2.0 * rad):
# 		minRad = 2.0 * rad
# 	stepSize = (maxRad - minRad)/numSteps
# 	r = 2.0*rad + (np.arange(numSteps) + 0.5)*stepSize
# 	outer = r + stepSize/2
# 	inner = r - stepSize/2
# 	g = np.zeros(numSteps)
# 	minSq = inner[0]**2
# 	stepSq = stepSize**2
# 	volumeSlice = (outer**dim - inner**dim) * p.hyperBallCoefficient(dim)
# 	if np.max(outer) > np.min(p.getBoxSize())/2.0:
# 		approxVolumeSlice = np.zeros(numSteps)
# 		maxSetSize = 1000000
# 		bins = np.append(np.array(inner[0])**2,outer**2)
# 		for ii in range(int(np.ceil(numVolumePoints/maxSetSize))):
# 			points = np.random.rand(maxSetSize,dim)*p.getBoxSize()
# 			pointDistance = np.sum((points - p.getBoxSize()/2.0)**2,1)
# 			place = np.digitize(pointDistance,bins)
# 			for i in range(maxSetSize):
# 				if (place[i] < numSteps and place[i]) >= 0:
# 					approxVolumeSlice[place[i]] += 1
# 		# 	bins = np.append(np.array(inner[0])**2,outer**2)
# 		# approxVolumeSlice = np.histogram(pointDistances,bins)[0]/numVolumePoints
# 	approxVolumeSlice /= numVolumePoints
# 	# print((volumeSlice - approxVolumeSlice)/volumeSlice)
# 	volumeSlice[outer > np.min(p.getBoxSize())/2.0] = approxVolumeSlice[outer > np.min(p.getBoxSize())/2.0]
# 	# for i in range(numSteps):
# 	# 	# r[i] = 2.0*rad + (i + 0.5)*stepSize
# 	# 	# outer[i] = r[i] + stepSize/2
# 	# 	# inner = r[i] - stepSize/2
# 	# 	if outer[i] < np.min(p.getBoxSize())/2.0:
# 	# 		volumeSlice[i] = (outer[i]**dim - inner[i]**dim) * p.hyperBallCoefficient(dim)
# 	# 	else:
# 	# 		volumeSlice[i] = np.sum(np.logical_and(pointDistances < outer[i]**2,pointDistances > inner[i]**2))/numVolumePoints
# 	for i in range(nParticles):
# 		if neighbors is None:
# 			if (i == nParticles - 1):
# 				break
# 			jRange = range(i+1,nParticles)
# 		else:
# 			jRange = neighbors.indices[neighbors.indptr[i]:neighbors.indptr[i+1]]
# 		for j in jRange:
# 			distance = p.pbcDistance(pos[i],pos[j])
# 			if distance < maxRad:
# 				g[int(np.floor((distance - 2.0*rad)/stepSize))] += 1 
# 	for i in range(numSteps):
# 		if neighbors is None:
# 			g[i] /= (nParticles * nParticles * volumeSlice[i] * 0.5)
# 		else:
# 			g[i] /= (nParticles * nParticles * volumeSlice[i])
# 	return g, r

# thisg,thisr = gofr(p.getPositions(),p.getRadii()[0],numR,maxRad = ((maxRad/p.getRadii()[0] - 1) * 4 + 1) * 2 * p.getRadii()[0],minRad = p.getRadii()[0]*2, neighbors = p.getNeighbors(),numVolumePoints = 100000)



dim = int(sys.argv[1])
numCells = int(sys.argv[2])
reducedRhoString = sys.argv[3]
basedir = sys.argv[4]


# dim = 3
# numCells = 18
# reducedRhoString = '0.95'
# basedir = '/work/pkm8/Data/crystalEOSLongNew/'

reducedRho = np.float64(reducedRhoString)
if dim==6:
	numCells = np.array([2,2,2,3,3,3])
	crystalPos, sides = e6.generateE6Crystal(numCells)
	maxPhi = e6.maxPhi()
	volPoints = 1000000
else:
	crystalPos, sides = dD.generatedDCrystal(numCells,dim)
	maxPhi = dD.maxPhi(dim)
	volPoints = 1000000

nParticles = crystalPos.shape[0]
saveDir = basedir + '/' + str(dim) + '/' + reducedRhoString + '/' + str(nParticles) + '/'


p = mc.MCPacking(dim,nParticles,maxPhi*reducedRho**dim)
maxR = (maxPhi/(nParticles * p.hyperBallCoefficient(dim)))**(1/dim)
p.setBoxSize(sides)

# p.setPositions(crystalPos)
# p.calcNeighborsCut(1)
# numAvgs = 35
# p.calcForceEnergy()
# p.minimizeFIRE(criticalForce = 1e-12)
# sigma = p.getMeanRadius()*2.0
# sigSq = sigma**2
# p.calcForceEnergy()
# minRadius = np.min(p.getRadii())
# maxDisp = p.findMCMaxDisplacement(hiDist = 1, distTol = 1e-4, neighborCut = 0.3,verbose = True)
# p.setMCMaxDisplacement(maxDisp)
# # Calculate what max displacement should be
# p.resetCenterOfMass()
# p.setPositions(crystalPos)
# numR = 80
# g = np.zeros(numR)
# r = np.zeros(numR)
# numMSD = 1000
# msd = np.zeros(numMSD)

# for i in range(numAvgs):
# 	p.calcNeighborsCut(0.3);
# 	p.calcForceEnergy()
# 	p.resetDisplacement()
# 	for j in range(numMSD):
# 		#Should check how far particles have moved and then recalculate neighbors if it's beyond max mc disp
# 		if (p.getSumOfMaxDisplacements()/(2*minRadius) >= 1):
# 			print('resetting at ' + str(j))
# 			p.calcNeighborsCut(0.3)
# 			p.resetDisplacement()
# 		p.MCStep()
# 		delta = p.getUnwrappedPositions() - p.getCenterOfMassShift() - crystalPos
# 		# msd[j] = np.mean(np.sum((delta - np.round(delta))**2,1))
# 		msd[j] = np.mean(np.sum(delta**2,1))
# 	p.calcNeighborsCut(0.3)
# 	thisg,thisr = p.gofr(p.getPositions(),p.getRadii()[0],numR,minRad = 2*p.getRadii()[0],maxRad = ((maxRad/p.getRadii()[0] - 1) * 4 + 1) * 2 * p.getRadii()[0],neighbors = p.getNeighbors())
# 	g = g+thisg
# 	r = thisr/(2*p.getRadii()[0])
# 	# p.save(saveDir + '/' + str(i))

# g = g/numAvgs
# limit = 30
# z = 1 + 2**(dim-1)*p.getPhi()*np.polyfit(r[:limit]-1,g[:limit],5)[-1]



# with open(saveDir + '/reducedPressure.dat','w') as file:
# 	file.write(str(z))

# # numAvgs = 22
numR = 150


# # for j in ['0.83','0.84','0.85','0.86','0.87','0.88','0.89','0.9','0.91','0.92','0.93','0.94','0.95','0.96','0.97','0.98','0.99']:
# 	# j = '0.94'
g = np.zeros(numR)
r = np.zeros(numR)
saveDir = basedir + '/' + str(dim) + '/' + reducedRhoString + '/' + str(nParticles) + '/'
numAvgs = len(glob.glob(saveDir + '/*/'))
for i in range(numAvgs):
	p.load(saveDir + '/' + str(i))
	maxDist = ((maxR/p.getRadii()[0] - 1) * 4 + 1) * 2 * p.getRadii()[0]
	cutDist = maxDist/(2*p.getRadii()[0]) - 1
	if (i==0):
		p.calcNeighborsCut(cutDist)
	p.calcForceEnergy()
	if (p.getEnergy() == 0.0):
		thisg,thisr = p.gofr(numR,maxRad = ((maxR/p.getRadii()[0] - 1) * 4 + 1) * 2 * p.getRadii()[0],minRad = p.getRadii()[0]*2,numVolumePoints = volPoints,logBin = True)
		g = g+thisg
		r = thisr/(2*p.getRadii()[0])
		# mc.fileIO.save2DArray(saveDir + '/' + str(i) + '/gofr.dat',np.stack((r,thisg),axis=1))
		# thisPressure = 1 + 2**(dim-1)*p.getPhi()*np.polyfit(r[:8]-1,thisg[:8],2)[-1]
		# # with open(saveDir + '/' + str(i) + '/pressure.dat', 'w') as file:
		# # 	file.write(str(thisPressure))
	else:
		numAvgs -= 1

g = g/numAvgs
# limit = 20
# z = 1 + 2**(dim-1)*p.getPhi()*np.polyfit(r[:limit]-1,g[:limit],4)[-1]
# with open(saveDir + '/reducedPressure2.dat','w') as file:
# 	file.write(str(z))
# mc.fileIO.save2dArray(saveDir + '/gofr.dat',msd)
mc.fileIO.save2DArray(saveDir + '/gofrLogNewForm.dat',np.stack((r,g),axis=1))
# gValues = np.zeros((5,20))
# for i in range(2,7):
# 	for j in range(10,30):
# 		gValues[i-2,j-10] = 1 + 2**(dim-1)*p.getPhi()*np.polyfit(r[:j]-1,g[:j],i)[-1]
