import monteCarloPCP as mc
import numpy as np
import Resources.crystalStructures.dDCrystal as dD

def my_round(some_float):
	return int(some_float * p + 0.5)/p

def pbcDist(p,mirror = np.zeros((9))):
	gind = 0
	summr = 0
	maxdelta = 0
	for i in range(9):
		mirror[i] = np.around(p[i])
		summr += mirror[i]
		p[i] -= mirror[i]
	if(summr%2 != 0):
		for i in range(9):
			dtmp = np.abs(p[i])
			if(maxdelta < dtmp):
				maxdelta = dtmp
				gind = i
		if(p[gind] < 0):
			mirror[gind] -= 1
			p[gind] += 1
		else:
			mirror[gind] += 1
			p[gind] -= 1
	return p,mirror

def returnDeleteList(pos):
	nParticles = len(pos)
	toDelete = np.zeros((nParticles))
	for i in range(nParticles-1):
		# print(i)
		if not toDelete[i]:
			for j in range(i+1,nParticles):
				if not toDelete[j]:
					# if np.all(pbcDist(pos[i]-pos[j])):
					dist = p.pbcDistance(modPos[i],modPos[j])
					if dist < 0.00001:
						toDelete[j] = 1
						# print(str(i) + " " + str(j))
	return toDelete


factor = 1
dim = 9
numCells = 6

cryPos,sides = dD.generatedDCrystal(numCells,dim)
nParticles = cryPos.shape[0]
maxPhi = dD.maxPhi(dim)

p = mc.MCPacking(dim,10,maxPhi * factor)
p.setGeometryType(mc.geometryEnum.Dn)


cryPos = (cryPos * 6 - 3)
cryPos = np.concatenate((cryPos,cryPos + np.array([0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0])))
cryPos = cryPos/3
# cryPos = cryPos-0.00001

# nParticles = len(cryPos)
# toDelete = np.zeros((nParticles))

# for i in range(nParticles):
# 	cryPos[i],mirror = pbcDist(cryPos[i])
# 	if np.any(mirror):
# 		toDelete[i] = 1

# cryPos1 = cryPos[np.where(1-toDelete)[0]]

# newPos = np.unique(cryPos1,axis=0)
# modPos = newPos
# nParticles = len(modPos)
# toDelete = np.zeros((nParticles))

cryPos = p.createD9Plus(cryPos)

# for i in range(nParticles-1):
# 	if not toDelete[i]:
# 		print(i)
# 		for j in range(i+1,nParticles):
# 			if not toDelete[j]:
# 				# if np.all(pbcDist(modPos[i]-modPos[j])):
# 				dist = p.pbcDistance(modPos[i],modPos[j])
# 				if dist < 0.00001:
# 					toDelete[j] = 1

# modPos = modPos[np.where(1-toDelete)[0]]
# nParticles = len(modPos)

mc.fileIO.save2DArray('/work/pkm8/Data/e9PosNew55.dat',cryPos)
nParticles = len(cryPos)

p = mc.MCPacking(dim,nParticles,maxPhi)
p.setGeometryType(mc.geometryEnum.Dn)
p.setPositions(cryPos)

p.save('/work/pkm8/Data/e9PosNew',overwrite=True)