import monteCarloPCP as mc
import numpy as np
import liquidCrystalCoexistence.dDCrystal as dD


factor = 0.8
dim = 4
numCells = 6
cryPos,sides = dD.generatedDCrystal(numCells,dim)
nParticles = cryPos.shape[0]
maxPhi = dD.maxPhi(dim)

p = mc.MCPacking(dim,nParticles,maxPhi * factor)
p.setBoxSize(sides)

p.setPositions(cryPos)
p.setMonoRadii()
p.calcNeighborsCut(0.2)
p.calcForceEnergy()
p.getEnergy()



p.minimizeFIRE(criticalForce=1e-10)
