import monteCarloPCP as mc
import numpy as np
import liquidCrystalCoexistence.e6Crystal as e6



maxPhi = e6.maxPhi()
factor = 0.8
numCells = np.array([2,1,2,3,5,1])
cryPos,sides = e6.generateE6Crystal(numCells)
nParticles = cryPos.shape[0]

p = mc.MCPacking(6,nParticles,maxPhi * factor)
p.setBoxSize(sides)

p.setPositions(cryPos)
p.setMonoRadii()
p.calcNeighborsCut(1)
p.calcForceEnergy()
p.getEnergy()

p.minimizeFIRE(criticalForce=1e-10)
