import monteCarloPCP as mc
import numpy as np
import Resources.crystalStructures.e7Crystal as e7




maxPhi = e7.maxPhi()
factor = 0.8
cryPos,sides = e7.generateE7Crystal()
nParticles = cryPos.shape[0]

p = mc.MCPacking(7,nParticles,maxPhi * factor)
p.setBoxSize(sides)

p.setPositions(cryPos)
p.setMonoRadii()
p.calcNeighborsCut(0.5)
p.calcForceEnergy()
p.getEnergy()

p.minimizeFIRE(criticalForce=1e-10)

