import monteCarloPCP as mc
import numpy as np
import sys
import os
import glob
import time
import Resources.crystalStructures.e8Crystal as e8
import Resources.crystalStructures.e7Crystal as e7
import Resources.crystalStructures.e6Crystal as e6
import Resources.crystalStructures.dDCrystal as dD
import Resources.crystalStructures.p10cCrystal as p10c


dim = int(sys.argv[1])
nParticles = int(sys.argv[2])
rhoString = sys.argv[3]
numTau = int(sys.argv[4])
basedir = sys.argv[5]

# dim = 4
# nParticles = 64
# rhoString = '0.583610017779866'
# numTau = 10
# basedir = '/hpc/home/pkm8/test/'


rho = np.float64(rhoString)
saveDir = basedir + '/' + str(dim) + '/' + rhoString + '/' + str(nParticles) + '/'

p = mc.MCPacking(dim,nParticles,0.1)

if dim == 3:
	p.setBiRadii()

if (dim > 5):
	p.setGeometryType(mc.geometryEnum.Dn)

phi = rho * p.hyperBallCoefficient(dim)/(2.0**dim)
p.setPhi(phi)

p.setRandomPositions()
p.calcNeighborsCut(1)

p.calcForceEnergy()
p.minimizeFIRE(criticalForce = 1e-12)
p.calcForceEnergy()

neighborCutDistance = 0
maxMCDisp = 0
for i in range(numTau):
	if i == 0:
		numSteps, tauAlpha, neighborCutDistance, maxMCDisp = p.thermalizePacking(verbose=True,numTrials=10,numCosts=5,numTau=1)
	else:
		numSteps, tauAlpha, neighborCutDistance, maxMCDisp = p.thermalizePacking(verbose=True,numTrials=10,numCosts=5,numTau=1,neighborCutDistance=neighborCutDistance,maxMCDisp=maxMCDisp)
	os.makedirs(saveDir + '/' + str(i),exist_ok=True)
	with open(saveDir + '/' + str(i) + '/tauAlpha.dat', 'w') as file:
		file.write(str(tauAlpha) + '\n')
