import monteCarloPCP as mc
import numpy as np
import sys
import os
from scipy.special import gamma
import time

# dim = int(sys.argv[1])
# xString = sys.argv[2]
# seed = int(sys.argv[3])
# basedir = sys.argv[4]

# seed = 100
# dim = 3
# xString = '0.736'
# basedir = '/work/pkm8/Data/perTest6/'

def powerRep(number,base,digits):
	# Turns a number into a representation in a base, cutoff such that the limit is base**digits
	# First, create an empty representation
	rep = [0]*digits
	for thisDigit in range(digits,0,-1):
		rep[thisDigit-1], number = divmod(number, base**(thisDigit-1))
	rep.reverse()
	return rep

pressure = np.array([0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1,2,3,4,5,6,7,8,9,10])
startingPhi = np.array([0.06680772441902963,
	0.13293412360654489,
	0.1887388182338932,
	0.2455089567836478,
	0.24951027196959197,
	0.27531115809671725,
	0.2921769165597818,
	0.32100406147380395,
	0.3505811590658653,
	0.39419422372826474,
	0.5160249103646546,
	0.5865437934643866,
	0.6451619310863496,
	0.695374481568817,
	0.7280088518549311,
	0.7350980049815721,
	0.7559242916466593,
	0.7698183967066342,
	0.770833552378665])
phiFinal = np.zeros(len(pressure))
for j in range(len(pressure)):
	# j = 16
	numRows = 6
	dim = 3
	nParticles = numRows**dim
	phi = startingPhi[j]
	p = mc.MCPacking(dim,nParticles,phi)
	p.setRandomSeed(0)
	p.setParticleType(mc.particleEnum.cube)
	crystalPos = p.getPositions()
	p.setPhi(phi)
	pos = p.getPositions()
	for i in range(nParticles):
		pos[i] = powerRep(i,numRows,dim)
	pos = pos/numRows
	pos = pos + p.getRandomVector(nParticles,dim)/10000
	p.setPositions(pos)
	p.calcNeighborsCut(1)
	p.calcForceEnergy()
	p.getEnergy()
	p.setTargetPressure(pressure[j])
	p.setMaxVolumeShift(0.2)
	p.setEnsembleType(mc.ensembleEnum.npt)
	p.setMonteCarloType(mc.monteCarloEnum.ecmc)
	# p.findMCMaxDisplacement()
	# p.setMCMaxDisplacement(0.2)
	p.setECMCLength(0.43)
	p.thermalizePacking(neighborCutDistance=100,numTau=10,maxMCDisp=0.43)
	# for i in range(10000):
	# 	p.MCStep()
	# #
	phiList = np.zeros(200)
	for i in range(200):
		p.MCStep()
		phiList[i] = p.getPhi()
	pos2 = p.getPositions()
	phiFinal[j] = np.mean(phiList)

# print(p.getPhi())

# p.setECMCLength(0.49)
# p.setMonteCarloType(mc.monteCarloEnum.ecmc)

# pos1 = p.getPositions()
	# for i in range(1000):
	# 	p.MCStep()
	# 	print(p.calcMCOverlap(pos))

	# pos2 = p.getPositions()

# for i in range(100):
# 	p.MCStepVolume();

# p.calcForceEnergy()
# p.getEnergy()

