import numpy as np
import monteCarloPCP as mc
import os.path
from scipy.special import gamma

def generateE7Crystal(version = 1):
	if version == 1:
		my_path = os.path.abspath(os.path.dirname(__file__))
		path = os.path.join(my_path, "e7N17496Pos.dat")
		print(path)
		cryPos = mc.fileIO.load2DArray(path,dtype=float)
		sides = np.ones(7)
	else:
		my_path = os.path.abspath(os.path.dirname(__file__))
		path = os.path.join(my_path, "e7N2048Pos.dat")
		print(path)
		cryPos = mc.fileIO.load2DArray(path,dtype=float)
		sides = np.ones(7)
	return cryPos, sides

def maxPhi():
	return ((np.pi**(7.0/2.0))/gamma(7.0/2.0 + 1))/16